/*
 * https://www.pjrc.com/teensy/td_libs_FreqMeasure.html
 * https://www.pjrc.com/teensy/td_libs_FreqCount.html
 * https://github.com/kosme/arduinoFFT
 * 
 * https://www.youtube.com/watch?v=5RmQJtE61zE
 */
const int SoundSensor = A5;
int sensorState;
int i=0, val;

#include <FreqCount.h>
#include <FreqMeasure.h>
#include <fix_fft.h>

double sum=0;
int ff=0;

char im[128], data[128];

void setup() {
  Serial.begin(9600);
  FreqMeasure.begin();
  FreqCount.begin(1000);
}

void loop() {
  sensorState = analogRead(SoundSensor);
  int min=1024, max=0;
  for(i=0; i<128; i++) {
    val = analogRead(SoundSensor);
    data[i] = val / 4 -128;
    im[i] = 0;
      if(val>max) val = max;
     if(val<min) val = min;
  }
  fix_fft(data, im, 7, 0);
  for(i=1; i<1200; i++) {
  //  Serial.println(im);
  }
  if (FreqCount.available()) {
    unsigned long fc = FreqCount.read();
    Serial.print("frequency: ");
    Serial.print(fc);
    Serial.println(" Hz");
  }
  if (FreqMeasure.available()) {
    // average several reading together
    sum = sum + FreqMeasure.read();
    ff = ff + 1;
    if (ff > 30) {
      float frequency = FreqMeasure.countToFrequency(sum / ff);
      Serial.print(frequency);
      Serial.println(" s");
      sum = 0;
      ff = 0;
    }
  } else {
    delay(1000);
    Serial.println("FreqMeasure is not available.");
  }
}

